#include "common.h"
#include "dg.h"

void usage()
/* Explain usage and exit. */
{
errAbort("dg - parse a dasgff file\n"
         "usage:\n"
	 "   dg dasgff.xml");
}

void dg(char *fileName)
/* Parse dasgff file. */
{
struct dgDasgff *dg = dgDasgffLoad(fileName);
struct dgSegment *seg;
struct dgFeature *feat;
int featCount = 0;

for (seg = dg->dgGff->dgSegment; seg != NULL; seg = seg->next)
    {
    for (feat = seg->dgFeature; feat != NULL; feat = feat->next)
        ++featCount;
    }
printf("Loaded %d features\n", featCount);
// dgDasgffSave(dg, 0, stdout);
}

int main(int argc, char *argv[])
{
if (argc != 2)
    usage();
dg(argv[1]);
return 0;
}
