/* tt.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "tt.h"

void *ttStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void ttEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void ttDasdsnSave(struct ttDasdsn *obj, int indent, FILE *f)
/* Save ttDasdsn to file. */
{
struct ttDsn *ttDsn;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASDSN>");
fprintf(f, "\n");
for (ttDsn = obj->ttDsn; ttDsn != NULL; ttDsn = ttDsn->next)
   ttDsnSave(ttDsn, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASDSN>\n");
}

struct ttDasdsn *ttDasdsnLoad(char *fileName)
/* Load ttDasdsn from file. */
{
struct ttDasdsn *obj;
xapParseAny(fileName, "DASDSN", ttStartHandler, ttEndHandler, NULL, &obj);
return obj;
}

void ttDsnSave(struct ttDsn *obj, int indent, FILE *f)
/* Save ttDsn to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DSN>");
fprintf(f, "\n");
ttSourceSave(obj->ttSource, indent+2, f);
ttDescriptionSave(obj->ttDescription, indent+2, f);
ttMapmasterSave(obj->ttMapmaster, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DSN>\n");
}

struct ttDsn *ttDsnLoad(char *fileName)
/* Load ttDsn from file. */
{
struct ttDsn *obj;
xapParseAny(fileName, "DSN", ttStartHandler, ttEndHandler, NULL, &obj);
return obj;
}

void ttSourceSave(struct ttSource *obj, int indent, FILE *f)
/* Save ttSource to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOURCE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOURCE>\n");
}

struct ttSource *ttSourceLoad(char *fileName)
/* Load ttSource from file. */
{
struct ttSource *obj;
xapParseAny(fileName, "SOURCE", ttStartHandler, ttEndHandler, NULL, &obj);
return obj;
}

void ttDescriptionSave(struct ttDescription *obj, int indent, FILE *f)
/* Save ttDescription to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DESCRIPTION");
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</DESCRIPTION>\n");
}

struct ttDescription *ttDescriptionLoad(char *fileName)
/* Load ttDescription from file. */
{
struct ttDescription *obj;
xapParseAny(fileName, "DESCRIPTION", ttStartHandler, ttEndHandler, NULL, &obj);
return obj;
}

void ttMapmasterSave(struct ttMapmaster *obj, int indent, FILE *f)
/* Save ttMapmaster to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<MAPMASTER>");
fprintf(f, "%s", obj->text);
fprintf(f, "</MAPMASTER>\n");
}

struct ttMapmaster *ttMapmasterLoad(char *fileName)
/* Load ttMapmaster from file. */
{
struct ttMapmaster *obj;
xapParseAny(fileName, "MAPMASTER", ttStartHandler, ttEndHandler, NULL, &obj);
return obj;
}

void *ttStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASDSN"))
    {
    struct ttDasdsn *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "DSN"))
    {
    struct ttDsn *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASDSN"))
            {
            struct ttDasdsn *parent = st->object;
            slAddHead(&parent->ttDsn, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SOURCE"))
    {
    struct ttSource *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct ttDsn *parent = st->object;
            slAddHead(&parent->ttSource, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct ttDescription *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct ttDsn *parent = st->object;
            slAddHead(&parent->ttDescription, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct ttMapmaster *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct ttDsn *parent = st->object;
            slAddHead(&parent->ttMapmaster, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void ttEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASDSN"))
    {
    struct ttDasdsn *obj = stack->object;
    if (obj->ttDsn == NULL)
        xapError(xp, "Missing DSN");
    }
else if (sameString(name, "DSN"))
    {
    struct ttDsn *obj = stack->object;
    if (obj->ttSource == NULL)
        xapError(xp, "Missing SOURCE");
    if (obj->ttSource->next != NULL)
        xapError(xp, "Multiple SOURCE");
    if (obj->ttDescription != NULL && obj->ttDescription->next != NULL)
        xapError(xp, "Multiple DESCRIPTION");
    if (obj->ttMapmaster == NULL)
        xapError(xp, "Missing MAPMASTER");
    if (obj->ttMapmaster->next != NULL)
        xapError(xp, "Multiple MAPMASTER");
    }
else if (sameString(name, "SOURCE"))
    {
    struct ttSource *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct ttDescription *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct ttMapmaster *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

